

def custom_code(self):
    ''' keep all custom code inside this function '''
    from qtvcp.widgets.simple_widgets import DoubleScale, PushButton
    from qtvcp.widgets.led_widget import LED

    min = 30 # minimum current setting
    max = 65 # maximum current setting

    def pwmgn_clicked(self):
        ''' set led state'''
        if STATUS.machine_is_on():
            self.h['pwm_led'] = True
            if self.cut_amps_pwmgn.isChecked():
                self.pwmgn_led.setFlashing(False)
            else:
                self.pwmgn_led.setFlashing(True)

    # get layout to add new frame to
    lay1 = self.w.control_frame.parent().children()[0]
    # remove control_frame from layout
    lay1.removeWidget(self.w.control_frame)
    # create new frame
    caf = QFrame(objectName='cut_amps_frame')
    lay2 = QVBoxLayout(objectName='cut_amps_layout')
    lay2.setContentsMargins(0, 0, 0, 0) # left, top, right, bottom
    lay2.setSpacing(4) # space between widgets
    caf.setLayout(lay2)
    cal = QLabel('CUT AMPS', objectName='cut_amps_label')
    cal.setAlignment(Qt.AlignCenter)
    lay2.addWidget(cal)
    g = QGridLayout(objectName='cut_amps_grid')
    g.setContentsMargins(4, 0, 4, 4) # left, top, right, bottom
    lay2.setSpacing(4) # space between widgets
    aa = DoubleScale()
    aa.setObjectName('cut_amps_set')
    aa.setRange(min, max)
    aa.setDecimals(0)
    aa.setValue(max)
    aa.setWrapping(True)
    aa.setAlignment(Qt.AlignRight)
    aa.set_pin_name('cut_amps_set')
    aa._hal_init()
    l1 = QLabel('ON')
    l1.setAlignment(Qt.AlignCenter)
    self.pwmgn_led = LED()
    self.pwmgn_led.set_pin_name('pwm_led')
    self.pwmgn_led._hal_init()
    self.cut_amps_pwmgn = PushButton('PWMGN ON/OFF')
    self.cut_amps_pwmgn.setObjectName='cut_amps_pwmgn'
    self.cut_amps_pwmgn.setCheckable(True)
    self.cut_amps_pwmgn.setisOnSensitive(True)
    self.cut_amps_pwmgn.set_pin_name('cut_amps_pwmgn')
    self.cut_amps_pwmgn._hal_init()
    self.cut_amps_pwmgn.clicked.connect(lambda:pwmgn_clicked(self))
    g.addWidget(self.cut_amps_pwmgn,0,0,2,2)
    g.addWidget(aa,2,0,4,1) # row, column, rows, columns
    g.addWidget(l1,2,1,2,1)
    g.addWidget(self.pwmgn_led,4,1,2,1)
    lay2.addLayout(g)
    # add new frame to layout
    lay1.addWidget(caf)
    # add control_frame to layout
    lay1.addWidget(self.w.control_frame)

    # patch handler power_state method so we can run some additional code
    old_power_state = self.power_state
    def new_power_state(state):
        old_power_state(state)
        if state:
            self.cut_amps_pwmgn.setChecked(True)
            self.cut_amps_pwmgn.setEnabled(True)
        else:
            self.cut_amps_pwmgn.setChecked(False)
            self.cut_amps_pwmgn.setEnabled(False)
        self.h['pwm_led'] = self.cut_amps_pwmgn.isChecked()
    self.power_state = new_power_state

custom_code(self)
